import React, { MouseEventHandler } from 'react';
import { Range, NodeEntry, Node } from 'slate';
import { HighlightEditor } from './use-highlight-slate';
import type { Select } from '../components/highlightLeaf';
export declare const SelectedTextContext: React.Context<[string, (txt: string) => void]>;
export declare const UnDecorateListContext: React.Context<[import("slate").BaseRange[], React.Dispatch<React.SetStateAction<import("slate").BaseRange[]>>]>;
declare type MouseHandlersFactory = (props: MouseHandlersFactoryProps) => {
    onMouseUp: MouseEventHandler;
    onMouseDown: MouseEventHandler;
};
declare type MouseHandlersFactoryProps = {
    validator?: (builtInValidator: (editor: HighlightEditor) => void, event: React.MouseEvent<HTMLDivElement>, editor: HighlightEditor) => boolean;
    callback?: (event: React.MouseEvent<HTMLDivElement>, editor: HighlightEditor) => void;
};
declare type DecorateFactory = ({ preDecorate, comparer, }: {
    preDecorate?: (entry: NodeEntry<Node>) => DecorateRange[];
    comparer?: (preRanges: DecorateRange[], ranges: DecorateSelectRange[]) => DecorateRange[];
}) => (entry: NodeEntry<Node>) => DecorateRange[];
declare type DecorateRange = Range & {
    [K: string]: any;
};
declare type DecorateSelectRange = Range & {
    select: Select;
};
export declare const useSelection: () => {
    createDecorate: DecorateFactory;
    createMouseHandlers: MouseHandlersFactory;
};
export {};
//# sourceMappingURL=use-selection.d.ts.map